<script setup lang="ts">
import { useStockStore } from '@/stores/stock'
import { ref } from 'vue'
import { useAuthStore } from '@/stores/auth'
import type { ReceiptItem } from '@/types/ReceiptItem'
import type { ReceiptStock } from '@/types/ReceiptStock'
import { onMounted } from 'vue'
import type { ReceiptStockItem } from '@/types/ReceiptStockItem'
import { useLoadingStore } from '@/stores/loading'
import ReportReceiptStock from './ReportReceiptStock.vue'
import { useReportStock } from '@/stores/reportStock'

const loadingStore = useLoadingStore()
const reportStockStore = useReportStock()
function showDateTime() {
  // show data and time in receipt
  const currentDate = new Date()
  // date components
  const year = currentDate.getFullYear()
  const month = currentDate.getMonth() + 1
  const day = currentDate.getDate()
  return `${year}-${month}-${day}`
}
function showTime() {
  // show data and time in receipt
  const currentDate = new Date()
  // time components
  const hours = currentDate.getHours()
  const minutes = currentDate.getMinutes()
  const seconds = currentDate.getSeconds()
  return `${hours}:${minutes}:${seconds}`
}
const stockStore = useStockStore()
function closeDialog(){
  stockStore.clear()
  stockStore.dialogShowReceiptOne = false
}
const authStore = useAuthStore()
const dialogReceipt = ref(false)
function showReceipt(r: ReceiptStock) {
     console.log(r);
    //  loadingStore.doLoad()
    stockStore.getReceipt(r.id!)
  //    stockStore.receiptStock.user = r.user
 
  // loadingStore.success()
  // dialogReceipt.value = !dialogReceipt.value
}


async function openReport(){
  // await reportStockStore.reportDay()
  stockStore.dialogReport = !stockStore.dialogReport
  setTimeout(() => {
  // Your code to be executed after delay
  stockStore.dialogShowReceipt = !stockStore.dialogShowReceipt
 
}, 100);

}

onMounted(() => {
  stockStore.getReceipts()
})
</script>

<template>
  <v-dialog
    v-model="stockStore.dialogShowReceipt"
    fullscreen
    :scrim="false"
    transition="dialog-bottom-transition"
  >
    <v-card>
      <v-toolbar dark color="#403c3c">
        <v-btn icon dark @click="stockStore.dialogShowReceipt = !stockStore.dialogShowReceipt">
          <v-icon>mdi-close</v-icon>
        </v-btn>
        <v-toolbar-title>Receipt Order</v-toolbar-title>
        <v-spacer></v-spacer>
      </v-toolbar>

      <v-container>
        <v-row>
          <v-sheet width="1250" height="500" class="overflow-auto">
            <v-table>
              <thead>
                <tr>
                  
                  <th>Tax Invoice</th>
                  <th>Name place</th>
                  <th>Total</th>
                  <th>Date</th>
                  <th>Action</th>
                </tr>
              </thead>
              <tbody>
                <tr v-for="item of stockStore.receiptStockS" :key="item.id">
                  <td>{{ item.idreceipt }}</td>
                  <td>{{ item.nameplace }}</td>
                  <td>{{ item.total }}</td>
                  <td>{{ item.Date }}</td>
                  <td>
                    <v-icon size="small" class="me-2" @click="showReceipt(item)"> mdi-eye </v-icon>
                  </td>
                </tr>
              </tbody>
            </v-table>
           
       
          </v-sheet>
          <v-btn color="primary" prepend-icon="mdi-chart-bar" @click="openReport()">Report</v-btn>
        </v-row>
      </v-container>
    </v-card>
 
  </v-dialog>

  <!-- Dialog โชว์ใบเสร็จ -->
  <v-dialog v-model="stockStore.dialogShowReceiptOne" persistent width="auto" height="auto" scrollable>
    <v-card>
      <v-card-title>ใบสั่งซื้อ</v-card-title>
      <v-card-text justify="center" align="center" style="border: 1px solid">
        <!-- head -->
        <!-- รายละเอียดส่วนข้างบน -->
        <v-container>
          <v-row justify="center">สถานที่ซื้อ: {{ stockStore.receiptStock.nameplace }}</v-row>
          <v-row style="font-size: 10px">-----------------------------------------------</v-row>
          <v-row style="font-size: 10px">วันที่:{{ stockStore.receiptStock.Date }}</v-row>
          <!-- <v-row style="font-size: 10px">เวลา:{{ stockStore.textDate[1] }}</v-row> -->
          <v-row style="font-size: 10px"
            >พนักงาน:{{ stockStore.receiptStock.user?.fullName}}</v-row
          >
          <v-row style="font-size: 10px">ใบกำกับภาษี:{{ stockStore.receiptStock.idreceipt }}</v-row>
       
          <br />
        </v-container>

        <v-divider></v-divider>
        <!-- ตาราง -->
        <v-container class="pa-0">
          <v-table density="compact">
            <thead>
              <tr style="font-size: 10px; text-align: left">
                <th>รายการ</th>
                <th>จำนวน</th>
                <th>ราคา</th>
              </tr>
            </thead>
            <tbody>
              <tr
                v-for="item of stockStore.receiptStock.receiptStockItems"
                :key="item.id"
                style="font-size: 10px; text-align: left"
              >
                <td>{{ item.name }}</td>
                <td>{{ item.unitPerItem }}</td>
                <td>{{ item.totalprice }} ฿</td>
              </tr>
            </tbody>
          </v-table>
        </v-container>
        <v-divider></v-divider>
        <!-- รายละเอียด -->
        <v-container class="pa-0" style="width: 300px">
          <v-row no-gutters>
            <v-col cols="12">-----------------------------------------------</v-col>
            <v-col cols="6" style="font-size: 11px; text-align: left"
              ><p>รวมเงินทั้งหมด: {{ stockStore.receiptStock.total }}</p></v-col
            >

            <v-col cols="12">-----------------------------------------------</v-col>
          </v-row>
        </v-container>
        <v-divider></v-divider>
        <p style="font-size: 11px; padding-top: 10px">ขอบคุณที่ใช้บริการค่ะ</p>
      </v-card-text>
      <v-card-actions>
        <v-spacer> </v-spacer>
        <v-btn @click="closeDialog()">ยกเลิก</v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
  <report-receipt-stock></report-receipt-stock>
</template>
<style scoped>
tbody tr:nth-of-type(even) {
  background-color: white;
}

tbody tr:nth-of-type(odd) {
  background-color: white;
}

thead {
  background-color: white;
  color: rgb(0, 0, 0);
  font-weight: bold;
}
.theme--light.v-data-table thead tr th {
  color: white;
}
</style>
